include .app_configured

ifeq ($(MAKE_USED),1)
include $(INCLUDE_DIR)/Rules.mk
include $(INCLUDE_DIR)/Makefile.common
-include $(UBOOT_CONFIG)

#CONFIG_PACKAGE_ifx-devm=y

APPS_NAME=IFXAPIs
APP_VERSION=
APP_TYPE=IFX
CONFIG_FULL_PACKAGE=y

ifeq ($(CONFIG_PACKAGE_IFX_DSL_CPE_API),y)
        BUILD_DEPENDS+=dsl_api
endif

ifeq ($(CONFIG_PACKAGE_ifx-oam),y)
        BUILD_DEPENDS+=oam
endif


IFX_APIS_DIR:=$(USER_IFXSOURCE_DIR)/IFXAPIs/
IFX_CFLAGS+=-I$(IFX_APIS_DIR)/include/
#IFX_CFLAGS+=-I$(USER_OPENSOURCE_DIR)/linux_atm/src/include/

all:configure compile install

IFXAPI_LDFLAGS-y:=$(IFX_LDFLAGS)

define menuconfig

config FEATURE_IFX_IFXAPIS
	bool 'IFXAPIs'
	help
	  IFXAPIs
	
config FEATURE_IFX_TURBONAT
	bool 'TurboNAT'
	help
	  Support for TurboNAT

config FEATURE_IFX_DEBUG
	bool 'Enable Debugs'
	help
	  Enable debug messages

config FEATURE_IPv6
	bool 'Enable IPv6 Support'
	help
	  Enable IPv6 Support

config FEATURE_RIP
	bool 'RIP Support'
	depends on FEATURE_ZEBRA
	help
	  Dynamic Routing support by RIP

config FEATURE_IFX_CHINA_MKT_1
	bool 'Enable Settings for China Market'
	help
	  Enable settings for China Market

config FEATURE_IFX_LOW_FOOTPRINT
	bool 'Enable Low FootPrint'
	help
	  Enable Low FootPrint

config FEATURE_IFX_USB_DEVICE
	bool 'Enable USB Device Mode Support'
	help
	  Enable USB Device Mode Support

config FEATURE_IFX_USB_DEVICE_MODULE
	bool 'USB Module Support'
	depends on FEATURE_IFX_USB_DEVICE
	help
	  USB Module Support

config FEATURE_IFX_USB_DEVICE_BUILTIN
	bool 'USB Builtin Support'
	depends on FEATURE_IFX_USB_DEVICE
	help
	  USB Builtin Support

config FEATURE_IFX_USB_HOST
	bool 'Enable USB Host Mode Support'
	help
	  Enable USB Host Mode Support

config FEATURE_CONFIG_FEATURE_IFX_ADM6996_UTILITY
	bool 'ADM6996 Utility'
	help
	  Support for ADM6996 utility

config FEATURE_IFX_WIRELESS
	bool 'wireless support'
   	depends on FEATURE_WIRELESS
	help
	  wireless support

config FEATURE_IFX_WIRELESS_RALINK
   bool 'Ralink Wireless'
   depends on FEATURE_IFX_WIRELESS
	default y
   help
      Support for Ralink

config FEATURE_IFX_WLAN_WMM
   bool 'Wi-Fi WMM support'
   depends on FEATURE_IFX_WIRELESS
	default y
   help
      Support for Wi-Fi WMM (Quality of Service)

config FEATURE_IFX_WLAN_WPS
   bool 'WiFi WPS support'
   depends on FEATURE_IFX_WIRELESS
	default y
   help
      Support for WPS feature (WiFi Protected Setup)

config FEATURE_IFX_DSL_MANAGEMENT
	bool 'DSL Management'
	help
	  DSL Management

config FEATURE_IFX_ILMI
	bool 'ILMI support'
	help
	  ILMI support

config FEATURE_IFX_VOIP
	bool 'VOIP support'
	help
	  VOIP support

config FEATURE_IFX_TAPIv3
	bool 'TAPI V3'
	help
	  TAPI V3 support

config FEATURE_FIREWALL
        bool 'Firewall support'
        help
          Firewall support

config FEATURE_NAPT
        bool 'NAPT support'
        help
          IP address and port translation support

config FEATURE_DHCP_SERVER
        bool 'DHCP Server support'
        help
          Support for DHCP Server configuration APIs

config FEATURE_DHCP_RELAY_
        bool 'DHCP Relay support'
        help
          Support for DHCP Relay configuration APIs

config FEATURE_ALGS
	bool 'Support for ALGs'
	help
	  Support for ALGs

config FEATURE_SELECTIVE_BACKUP_RESTORE 
	bool 'Support for Partial Backup and Restore'
	help
	  Support for Partial Backup and Restore

endef

IFXAPIS_INC_DIR	=$(USER_IFXSOURCE_DIR)/IFXAPIs/include/

ifeq ($(CONFIG_PACKAGE_IFX_DSL_CPE_API),y)
IFX_CFLAGS-y	+=-DLINUX -I$(USER_IFXSOURCE_DIR)/dsl_api/drv_dsl_cpe_api/src/include \
		-I$(USER_IFXSOURCE_DIR)/dsl_api/dsl_cpe_control/src \
		-DDSL_CHANNELS_PER_LINE=1
	
	ifeq ($(CONFIG_IFX_CONFIG_CPU),"AMAZON_SE")
		IFX_CFLAGS-y	+=-DINCLUDE_DSL_CPE_API_DANUBE -DCONFIG_FEATURE_IFX_DSL_CPE_API
	endif
	
	ifeq ($(CONFIG_IFX_CONFIG_CPU),"DANUBE")
		IFX_CFLAGS-y	+=-DINCLUDE_DSL_CPE_API_DANUBE -DCONFIG_FEATURE_IFX_DSL_CPE_API
	endif

	ifeq ($(CONFIG_IFX_CONFIG_CPU),"AMAZON_S")
		IFX_CFLAGS-y	+=-DINCLUDE_DSL_CPE_API_DANUBE -DCONFIG_FEATURE_IFX_DSL_CPE_API
	endif

endif

ifeq ($(CONFIG_FEATURE_IFX_TR69_IPPING),y)
	IFX_CFLAGS-y	+=-DIFX_TR69_IPPING 
endif

ifeq ($(CONFIG_FEATURE_IFX_SWITCH_UTILITY),y)
	IFX_CFLAGS-y    +=-I$(USER_IFXSOURCE_DIR)/switch_utility/include
endif

IFX_CFLAGS-$(CONFIG_FEATURE_SNMPv3)			+=-DCONFIG_FEATURE_SNMPv3
IFX_CFLAGS-$(CONFIG_FEATURE_SMASH_SNMP)			+=-DCONFIG_FEATURE_SMASH_SNMP
IFX_CFLAGS-y						+=-DCPU_AMAZON_S -I$(UBOOT_SOURCE_DIR)include
IFX_CFLAGS-$(CONFIG_PACKAGE_ifx-devm)			+=-DTR69_DEFINED -DAMAZON
IFX_CFLAGS-y						+=-DAMAZON
IFX_CFLAGS-$(CONFIG_FEATURE_IFX_WIRELESS)		      +=-DCONFIG_FEATURE_IFX_WIRELESS
IFX_CFLAGS-$(CONFIG_FEATURE_IFX_WIRELESS_RALINK)	+=-DCONFIG_FEATURE_IFX_WIRELESS_RALINK
IFX_CFLAGS-$(CONFIG_FEATURE_IFX_WLAN_WMM)          +=-DIFX_MAPI_WLAN_WMM
IFX_CFLAGS-$(CONFIG_FEATURE_IFX_WLAN_WPS)          +=-DIFX_MAPI_WLAN_WPS
IFX_CFLAGS-$(CONFIG_FEATURE_IFX_WIRELESS_TSC)		+=-DCONFIG_FEATURE_IFX_TSC_WLAN \
							-I$(USER_IFXSOURCE_DIR)/thomson-wlan-rel-2b/Lib/Source/H/ \
							-I$(USER_IFXSOURCE_DIR)/thomson-wlan-rel-2b/Cli/Source/H/
IFX_CFLAGS-$(CONFIG_FEATURE_IFX_TR69_DEVICE_ASSOCIATION)          +=-DDEVICE_ASSO_SUPPORT
IFX_CFLAGS-y						+=-DIFX_SMALL_FOOTPRINT -DIFX_DLOAD_LIBCRYPT
IFXAPI_LDFLAGS-$(CONFIG_PACKAGE_ifx-oam)		+=-loamapi
IFXAPI_LDFLAGS-$(CONFIG_FEATURE_IFX_WIRELESS_TSC)	+=-L$(USER_IFXSOURCE_DIR)/thomson-wlan-rel-2b/Lib/Debug -lmaxBaseLinux_tsc -lpthread

IFX_CFLAGS						+=$(IFX_CFLAGS-y)
IFX_LDFLAGS						+=$(IFX_LDFLAGS-y)
IFXAPI_LDFLAGS						:=$(IFXAPI_LDFLAGS-y)
IFX_CFLAGS                                              +=-DIFX_IMAGE_EXTRA_CHECKS
define configure

endef

define compile
	$(MAKE) $(BUILD_FLAGS) IFX_CFLAGS="$(IFX_CFLAGS)" IFX_LDFLAGS="$(IFX_LDFLAGS)" \
	IFXAPI_LDFLAGS="$(IFXAPI_LDFLAGS)" BUILD_TOOLS_DIR=$(BUILD_TOOLS_DIR) \
	TSC_LIB="$(USER_IFXSOURCE_DIR)/thomson-wlan-rel-2b/Lib/Debug/libmaxBaseLinux.a" \
	TOOLCHAIN_LIB_PATH="$(LIBPATH)" -C src
	$(IFX_STRIP) --strip-unneeded $(IFX_APIS_DIR)/lib/*
endef

define install
	install -d $(BUILD_ROOTFS_DIR)/lib/
	cp -f $(IFX_APIS_DIR)/lib/*.so $(BUILD_ROOTFS_DIR)/lib/.
endef

define clean
	$(MAKE) -C src clean
        find . -name '*.a' | xargs rm -f
endef

define distclean
	$(MAKE) -C src clean
        find . -name '*.a' | xargs rm -f
endef

$(eval $(call define_eval_application))
.EXPORT_ALL_VARIABLES:
else
export MAKE_USED=1
all %:
	@$(MAKE) -s -C $(BUILD_TOOLS_DIR) make_installed
	@$(BUILD_TOOLS_DIR)/tmp/bin/make -f ifx_make.mk $@
endif
